VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Background Task Launcher"
   ClientHeight    =   2745
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2985
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2745
   ScaleWidth      =   2985
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdLaunch 
      Caption         =   "&Launch Task #2"
      Height          =   495
      Index           =   1
      Left            =   600
      TabIndex        =   3
      Top             =   1200
      Width           =   1935
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   600
      TabIndex        =   2
      Top             =   1920
      Width           =   1935
   End
   Begin VB.CommandButton cmdLaunch 
      Caption         =   "&Launch Task #1"
      Height          =   495
      Index           =   0
      Left            =   600
      TabIndex        =   1
      Top             =   600
      Width           =   1935
   End
   Begin VB.Timer tmrStopWatch 
      Interval        =   500
      Left            =   0
      Top             =   1200
   End
   Begin VB.Label lblTime 
      BackColor       =   &H00000000&
      Caption         =   "99:99:99  XM"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00008000&
      Height          =   375
      Left            =   600
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents m_ObjTask1   As CAsynchTask
Attribute m_ObjTask1.VB_VarHelpID = -1
Private WithEvents m_ObjTask2   As CAsynchTask
Attribute m_ObjTask2.VB_VarHelpID = -1

Private m_intTaskCounter        As Integer

Private Sub cmdExit_Click()
    Unload Me
End Sub


Private Sub Form_Load()
    m_intTaskCounter = 0
End Sub

Private Sub Form_Terminate()
    Set m_ObjTask1 = Nothing
    Set m_ObjTask2 = Nothing
End Sub

Private Sub tmrStopWatch_Timer()
    lblTime.Caption = Format$(Now, "HH:MM:SS AMPM")
    Me.Refresh
End Sub

Private Sub cmdLaunch_Click(Index As Integer)
    Select Case Index
    Case 0
        Set m_ObjTask1 = New CAsynchTask
        m_ObjTask1.StartTask
    Case 1
        Set m_ObjTask2 = New CAsynchTask
        m_ObjTask2.StartTask
    End Select
    
    SetUI Index, False
End Sub

Private Sub SetUI(intTaskID As Integer, blnEnabled As Boolean)
    cmdLaunch(intTaskID).Enabled = blnEnabled
    
    If blnEnabled Then
        m_intTaskCounter = m_intTaskCounter - 1
    Else
        m_intTaskCounter = m_intTaskCounter + 1
    End If
    
    If m_intTaskCounter = 0 Then
        cmdExit.Enabled = True
    Else
        cmdExit.Enabled = False
    End If
End Sub

Private Sub m_ObjTask1_OnComplete()
    SetUI 0, True
End Sub

Private Sub m_ObjTask2_OnComplete()
    SetUI 1, True
End Sub
